#include <gtk/gtk.h>
#include <libchroma/chroma-list-selection.h>

/* Container Plugin IFace */
static void
chroma_list_selection_iface_base_init (gpointer g_class)
{
        static gboolean initialized = FALSE;

        if (!initialized) {
                /* create interface signals here. */
                initialized = TRUE;
        }
}

GType
chroma_list_selection_iface_get_type (void)
{
        static GType type = 0;
        if (type == 0) {
                static const GTypeInfo info = {
                        sizeof (ChromaListSelectionInterface),
                        chroma_list_selection_iface_base_init,   /* base_init */
                        NULL,   /* base_finalize */
                        NULL,   /* class_init */
                        NULL,   /* class_finalize */
                        NULL,   /* class_data */
                        0,
                        0,      /* n_preallocs */
                        NULL    /* instance_init */
                };
                type = g_type_register_static (G_TYPE_INTERFACE, "ChromaListSelectionInterface", &info, 0);
        }
        return type;
}

GList*
chroma_list_selection_get_selected_paths (ChromaListSelectionInterface *self)
{
	g_return_val_if_fail (CHROMA_IS_LIST_SELECTION(self), NULL);

        return CHROMA_LIST_SELECTION_GET_IFACE (self)->get_selected_paths (self);
}

gboolean
chroma_list_selection_iter_get_selected (ChromaListSelectionInterface *self, GtkTreeIter *iter)
{
	g_return_val_if_fail (CHROMA_IS_LIST_SELECTION(self), FALSE);

        return CHROMA_LIST_SELECTION_GET_IFACE (self)->iter_get_selected (self, iter);
}

void
chroma_list_selection_iter_set_selected (ChromaListSelectionInterface *self, GtkTreeIter *iter, gboolean selected)
{
	g_return_if_fail (CHROMA_IS_LIST_SELECTION(self));

	CHROMA_LIST_SELECTION_GET_IFACE (self)->iter_set_selected (self, iter, selected);
}
